Page MenuHomeVyOS Platform

On xen-netback interfaces must set "scattergather" offload before MTU>1500
Closed, ResolvedPublicBUG

Description

When running on Xen, with interfaces provided by the xen-netback driver, sg offload must be enabled before the MTU can be increased beyond 1500 — otherwise setting MTU on the underlying interface fails and VyOS produces its crash report.

Discussed in forum with reference to relevant line 367 of xen-netback/interface.c

If VyOS can determine that the ethernet device being configured is a xen-netback driver, then VyOS should refuse configuration of MTU>1500 unless sg is enabled.

Alternatively, a dirty fix would be to emit a warning that sg might needed if the user is configuring jumbo MTUs.

Details

Difficulty level
Easy (less than an hour)
Version
1.3-beta
Why the issue appeared?
Will be filled on close
Is it a breaking change?
Perfectly compatible

Event Timeline

maznu renamed this task from Must set "scattergather" offload before MTU to On xen-netback interfaces must set "scattergather" offload before MTU>1500.Feb 19 2021, 4:59 AM
maznu updated the task description. (Show Details)
c-po changed the task status from Open to In progress.Feb 19 2021, 7:38 AM
c-po claimed this task.
c-po triaged this task as Normal priority.

A verify() step will be added to prevent certain configurations when a specific type of driver is used. In this case if the xen driver is used, and MTU is > 1500 and sg is not set, a ConfigError() will be raised.

@maznu can you please share the output of: show interfaces ethernet eth0 physical

Sure thing:

vyos@vlns:~$ show interfaces ethernet eth2 physical
Settings for eth2:
        Link detected: yes
driver: vif
version:
firmware-version:
expansion-rom-version:
bus-info: vif-0
supports-statistics: yes
supports-test: no
supports-eeprom-access: no
supports-register-dump: no
supports-priv-flags: no
vyos@vlns:~$ show interfaces ethernet eth1 physical
Settings for eth1:
        Link detected: yes
driver: vif
version:
firmware-version:
expansion-rom-version:
bus-info: vif-1
supports-statistics: yes
supports-test: no
supports-eeprom-access: no
supports-register-dump: no
supports-priv-flags: no
c-po changed the task status from In progress to Needs testing.Feb 20 2021, 7:53 PM
c-po changed the task status from Needs testing to Backport pending.
c-po changed the task status from Backport pending to Needs testing.Feb 21 2021, 7:08 PM